* PROGRAM: FRXDUMP.PRG

* Prints report form layout

* By Carl Karsten
* CIS: 73252,3340

* Mon  05-09-1994

PARAMETERS PMSK, PGO

close all
SET TALK OFF
set safe off

ZPRNCOD = 'CHR(15)'+SPACE(30)
ZUON = 'CHR(27)+"-1"' + SPACE(30)
ZUOFF = 'CHR(27)+"-0"' + SPACE(30)

XFILNAM = STRTRAN(SYS(16),".FXP","")
IF FILE( XFILNAM+".MEM" )
  RESTORE FROM (XFILNAM) ADDITIVE
ENDIF

IF PARAMETERS()>1
  KEYBOARD "{Ctrl+Enter}"
ENDIF

DO (XFILNAM+".SPX")

RETURN
* EOP: (main) i:\frx\frxdump.prg *
****************************************************************************
PROCEDURE LPRN

* Called from OK Button
* Calls LONEFRX for each .FRX that matches the file mask.

SAVE ALL LIKE Z* TO (XFILNAM)

XUON = EVAL(ZUON)
XUOFF = EVAL(ZUOFF)

XMSK = PMSK+".FRX"

XFIL = SYS( 2000, XMSK )
DO WHILE !EMPTY(XFIL)

  USE (XFIL) ALIAS FRX
  DO LONEFRX
  CLOSE ALL
  
  XFIL = SYS( 2000, XMSK, 1 )
  
ENDDO

SET TALK ON
       
RETURN
****************************************************************************
PROCEDURE LONEFRX

* Dumps one .FRX

* XFOT() -- Foot Notes -- Used when there is to much text and not enough space.
XMAXFOT = 2
DIMENSION XFOT(100)
XFOTCTR = 0

SET FILTER TO PLATFORM = "DOS"

* xmaxgrp = number of groups
SELECT EXPR FROM (DBF()) INTO ARRAY XGRPEXP WHERE OBJTYPE=9 AND OBJCODE = 3
XMAXGRP = _TALLY

SET PRINTER TO (TRIM(ZPRNDEV))
SET PRINTER ON

* Print any controle codes to set condensed, whatever....
IF !EMPTY( ZPRNCOD )
  ??? EVAL( ZPRNCOD )
ENDIF

* Print FRX File Name.
? XFIL

* Print info stored in the FRX header reccord.
IF ZPHED
  DO LHED
ENDIF

* Print Bands
DO LBNDS

* Print Variables
IF ZVAR
  DO LVAR
ENDIF

* Print Foot Notes
DO LFOT

IF ZEJT
  EJECT
ENDIF

SET PRINT OFF

RETURN
* EOP: LONE *
****************************************************************************
PROCEDURE LHED
* Header
* Name, definition, size

LOCATE FOR OBJTYPE = 1

IF SUMMARY
  ?"Summary"
ENDIF
? "Objcode", OBJCODE, " Height", LNUM(HEIGHT), " Width", LNUM(WIDTH)
?

RETURN
* EOP: LHED *
****************************************************************************
PROCEDURE LBNDS

* Bands
* Title, Page header, group headers, detail group footers, page foot, summary.

XFLT = "OBJTYPE = 9"

SELECT * FROM FRX INTO CURSOR FRXHED WHERE &XFLT

DO CASE
  CASE ZBNDPOS = 1
    * No header info, just printalbe objects
    DO LBNDS2 WITH 0
  CASE ZBNDPOS = 2
    * Print in seperate groups,
    * First, just header info
    * then just printable objects.
    DO LBNDS2 WITH 2
    DO LBNDS2 WITH 0
  CASE ZBNDPOS = 3
    * Print header info at the begining of each band
    DO LBNDS2 WITH 1
  CASE ZBNDPOS = 4
    * Print in seperate groups,
    * First, just printable objects.
    * then just header info
    DO LBNDS2 WITH 0
    DO LBNDS2 WITH 2
ENDCASE

RETURN
* EOP: LBNDS *
****************************************************************************
PROCEDURE LBNDS2

PARAMETER ZBNDMOD

XSVPOS = 0
XEVPOS = 0

XGRPLEV = 0

SCAN

  XOBJCODE = OBJCODE

  IF XOBJCODE = 3
    XGRPLEV = XGRPLEV + 1
  ENDIF

  XEVPOS = XSVPOS + HEIGHT-1

  DO LONEBND WITH XOBJCODE, ZBNDMOD

  XSVPOS = XEVPOS +1

  IF XOBJCODE = 5
    XGRPLEV = XGRPLEV - 1
  ENDIF

ENDSCAN

RETURN
* EOP: LBNDS2 *
****************************************************************************
PROCEDURE LONEBND

* Prints one band

PARAMETERS POBJCODE, ZBNDMOD

* Check to see if the user wants to print the band type we are on
IF  ( POBJCODE = 0 AND ZPTIT );
 OR ( POBJCODE = 1 AND ZPPAGHED );
 OR ( POBJCODE = 3 AND ZPGRPHED );
 OR ( POBJCODE = 4 AND ZPDET );
 OR ( POBJCODE = 5 AND ZPGRPFOT );
 OR ( POBJCODE = 7 AND ZPPAGFOT );
 OR ( POBJCODE = 8 AND ZPSMY )

  IF INLIST(ZBNDMOD, 1, 2)
    * Band header
    DO LBNDHED
  ENDIF

  IF INLIST(ZBNDMOD, 0, 1)
    * Band Objects
    DO LBNDOBJ
  ENDIF

ENDIF

RETURN
* EOP: LONEBND *
****************************************************************************
PROCEDURE LBNDOBJ


FOR XVPOS = XSVPOS TO XEVPOS

  DO LROW WITH XVPOS

ENDFOR

RETURN
* EOP: LBNDOBJ *
****************************************************************************
PROCEDURE LBNDHED

* Band Header info

DO CASE
  CASE POBJCODE=0
    ? "Title"
  CASE POBJCODE=1
    ? "Page Header"
  CASE POBJCODE=3
    ? "Group Header:" + LNUM(XGRPLEV) + " " + LUL( EXPR )
  CASE POBJCODE=4
    ? "Detail"
  CASE POBJCODE=5
    ? "Group Footer:" + LNUM(XGRPLEV) + " " + LUL( XGRPEXP( XGRPLEV) )
  CASE POBJCODE=7
    ? "Page Footer"
  CASE POBJCODE=8
    ? "Summary"
  CASE POBJCODE=9
    ? ""
  OTHERWISE
    ? ""
ENDCASE

?? "  Height", LNUM(HEIGHT)

?? LLGLFLD( PAGEBREAK, " Page Break" )
?? LLGLFLD( RESETPAGE, " Reset Page Number" )
?? LLGLFLD( NOREPEAT, " Reprint Header" )
?? LLGLFLD( SWAPHEADER, " Swap Header" )
?? LLGLFLD( SWAPFOOTER, " Swap Footer" )

IF !EMPTY(OFFSET)
  ?? "# of rows followint header: ", LNUM(OFFSET)
ENDIF
?
RETURN
* EOP: LBNDHED *
****************************************************************************
PROCEDURE LROW

* Prints one row of the frx.
* May make more than one row of output.

PARAMETER PVPOS, PBNDTYP

* Get print objects that are on this row
SELECT * FROM FRX INTO CURSOR FRXROW;
 WHERE INLIST(OBJTYPE, 5, 8) AND VPOS = PVPOS;
 ORDER BY HPOS

* Number of objects in this row
COUNT TO XNUMOBJ

XVPOSOFF = 0

IF ZVPOSNOS
  ?? "#"+LNUM(PVPOS) AT 0
  XVPOSOFF = XVPOSOFF + 4
ENDIF

*IF PVPOS=11
*  SUSPEND
*ENDIF

IF ZBNDNAM
  ?? LBNDNAM()
  XVPOSOFF = XVPOSOFF + 3
ENDIF

IF XNUMOBJ > 0

  XOBJNO = 0

  * Maximun number of lines for one row
  XMAXLIN = 100

  * Array of output - Objects X Lines
  * Each object in the report gets as many XLIN( XOBJNO, x ), ONE x FOR
  * each line of output it will take.  if the output wont fit, foot note it.
  DIME XLIN( XNUMOBJ, XMAXLIN )

  SCAN

    XOBJNO = XOBJNO + 1
    * XLINPTR points to the current XLIN( XOBJNO, x ) as x goes from 1 to ?.
    XLINPTR = 0

    IF TYPE( EXPR ) = "C"
      DO LADDLIN WITH EVAL( EXPR )
    ELSE
      DO LADDLIN WITH EXPR, .T.
    ENDIF

    IF ZPIC AND !EMPTY(PICTURE)
      IF TYPE(PICTURE) = 'C'
        XPIC = EVAL(PICTURE)
      ELSE
        XPIC = PICTURE
      ENDIF
      IF XPIC = '@'
        DO LADDLIN WITH SUBSTR( XPIC, 1, AT( " ", XPIC )-1 )
        DO LADDLIN WITH SUBSTR( XPIC, AT( " ", XPIC )+1 )
      ELSE
        DO LADDLIN WITH XPIC
      ENDIF
    ENDIF

    IF ZATR
      DO LADDLIN WITH STYLE
      DO LADDLIN WITH LLGLFLD( FLOAT, "Float" )
      DO LADDLIN WITH LLGLFLD( STRETCH, "Stretch" )
      DO LADDLIN WITH LLGLFLD( NOREPEAT, "NoRepeat" )
      DO LADDLIN WITH LLGLFLD( NOREPEAT, LRST(RESETRPT) ), .t., 0
    ENDIF

    IF ZCAL AND TOTALTYPE > 0
      DO LADDLIN WITH LTOTTYP( TOTALTYPE )
      DO LADDLIN WITH LRST( RESETTOTAL ), .t., 0
    ENDIF

    IF ZCMT
      DO LADDLIN WITH COMMENT
    ENDIF

    IF XLINPTR > ZMAXSTR
      XTXT = ''
      FOR XCTR = 1 TO XLINPTR
        XTXT = XTXT + XLIN(XOBJNO, XCTR)
        XLIN(XOBJNO, XCTR) = ''
      ENDFOR
      XLIN(XOBJNO, 1) = LUL(LADDFOT( XTXT ))
    ENDIF

  ENDSCAN

  * Now print XLIN array.  FOR loop is for lins of output,
  * SCAN is for each object.  SCAN and not FOR, because we need HPOS
  * for each object's posision.

  FOR XLINNO = 1 TO XMAXLIN

    XPRTED = .F.
    XOBJNO = 0

    SCAN

      XOBJNO =  XOBJNO + 1
      IF !EMPTY( XLIN(XOBJNO, XLINNO ) )
        ?? XLIN(XOBJNO, XLINNO ) AT HPOS + XVPOSOFF
        XPRTED = .T.
      ENDIF

    ENDSCAN

    IF !XPRTED
      EXIT
    ENDIF

    ?

  ENDFOR

ELSE

  ?

ENDIF

* Line spacing: we are already on a new line, so print any lines over 1
FOR XCTR = 2 TO ZLINSPC
  ?
ENDFOR

RETURN
* EOP: LROW *
****************************************************************************
PROCEDURE LBNDNAM
DO CASE
  CASE POBJCODE=0
    RETURN "T"
  CASE POBJCODE=1
    RETURN "PH"
  CASE POBJCODE=3
    RETURN LNUM(XGRPLEV)
  CASE POBJCODE=4
    RETURN "D"
  CASE POBJCODE=5
    RETURN LNUM(XGRPLEV)
  CASE POBJCODE=7
    RETURN "PF"
  CASE POBJCODE=8
    RETURN "S"
  OTHERWISE
    RETURN ""
ENDCASE

* EOP: LBNDNAM *
****************************************************************************
PROCEDURE LVAR

* Get Variable objects

SELECT * FROM FRX INTO CURSOR FRXVAR WHERE OBJTYPE = 18

IF RECCOUNT() > 0
  ?
  ? "Variables"
  SCAN
*    ? "          Name:", LUL( NAME )
    ? LUL( NAME )
    IF TAG <> '0'
      ? " Initial Value:", LUL( TAG )
    ENDIF
    ?? " Value to Store:", LUL( EXPR )
    DO LPRTLIN WITH LLGLFLD( !UNIQUE, "Don't Release After Report" )
    IF TOTALTYPE > 0
      DO LPRTLIN WITH LTOTTYP(TOTALTYPE) + " " + LUL(LRST(RESETTOTAL))
    ENDIF
    ?
  ENDSCAN
ENDIF

RETURN
* EOP: LVAR *
****************************************************************************
PROCEDURE LFOT

* Print Footnotes

IF XFOTCTR > 0
  ?
  FOR XCTR = 1 TO XFOTCTR
    ? "*"+LNUM(XCTR)+" "+XFOT(XCTR)
*    ?
  ENDFOR
ENDIF

RETURN
* EOP: LFOT *
****************************************************************************
PROCEDURE LTOTTYP

* convert totaltype to a string

PARAMETER PTOTTYP
DO CASE
  CASE PTOTTYP = 0
    RETURN ""
  CASE PTOTTYP = 1
    RETURN "Count "
  CASE PTOTTYP = 2
    RETURN "Sum "
  CASE PTOTTYP = 3
    RETURN "Avg "
  CASE PTOTTYP = 4
    RETURN "Min "
  CASE PTOTTYP = 5
    RETURN "Max "
  CASE PTOTTYP = 6
    RETURN "Std. Dev "
  CASE PTOTTYP = 7
    RETURN "Variance "
  OTHERWISE
    RETURN "Tot"+LNUM(PTOTTYP)+" "
ENDCASE

* EOP: LTOTTYP *
****************************************************************************
PROCEDURE LRST

* Convert Reset to a string

PARAMETER PRST
DO CASE
  CASE PRST = 0
    RETURN "Reset EOR "
  CASE PRST = 1
    RETURN "Reset EOP "
  CASE PRST > XMAXGRP + 2
    RETURN "Reset Invalid! ("+STR( PRST-2,3 )+") "
  OTHERWISE
    RETURN "Reset "+XGRPEXP( PRST-2 )+" "
ENDCASE

* EOP: LRST *
****************************************************************************
PROCEDURE LADDLIN

* Add a line of text to XLIN array.
* if no text is passed, don't add any lines
* if text is too long, break up into many lines

* if not passed:
* PUL defaults to .f.
* PWTH defaults to WIDTH (field from the FRX or a cursur selected from frx)

PARAMETERS PTXT, PUL, PWTH

PRIVATE XTXT, XUL, XWTH

IF EMPTY( PTXT )
  RETURN
ENDIF

XTXT = PTXT

IF PARAMETERS()>1
  XUL = PUL
ELSE
  XUL = .F.
ENDIF

IF PARAMETERS()>2
  IF PWTH = 0
    XWTH = LEN(PTXT)
  ELSE
    XWTH = PWTH
  ENDIF
ELSE
  XWTH = WIDTH
ENDIF

DO WHILE LEN(XTXT)>WIDTH
  IF XLINPTR <= XMAXLIN
    XLINPTR = XLINPTR + 1
  ENDIF
  IF XUL
    XLIN( XOBJNO, XLINPTR ) = LUL( SUBSTR( XTXT, 1, WIDTH ) )
  ELSE
    XLIN( XOBJNO, XLINPTR ) =  SUBSTR( XTXT, 1, WIDTH )
  ENDIF
  XTXT = SUBSTR( XTXT, WIDTH+1 )
ENDDO

IF XLINPTR <= XMAXLIN
  XLINPTR = XLINPTR + 1
ENDIF

IF XUL
  XLIN( XOBJNO, XLINPTR ) = LUL( XTXT, XWTH ) + " "
ELSE
  XLIN( XOBJNO, XLINPTR ) =  XTXT + " "
ENDIF

RETURN
* EOP: LADDLIN *
****************************************************************************
PROCEDURE LADDFOT

* Create a new foot note, put text into it, and return a referance

PARAMETER PTXT

PRIVATE XTXT

IF XFOTCTR = XMAXFOT
  XMAXFOT = XMAXFOT *2
  DIMENSION XFOT( XMAXFOT )
ENDIF
XFOTCTR = XFOTCTR +1

XFOT( XFOTCTR ) = PTXT

XTXT = "*"+LNUM(XFOTCTR)

* Take out printer codes
PTXT = STRT( PTXT, XUON, "")
PTXT = STRT( PTXT, XUOFF, "")

IF LEN(XTXT) < WIDTH
  XTXT = XTXT + " " + PTXT
ENDIF

XTXT = PADR( XTXT, WIDTH, "." )

RETURN XTXT
* EOP: LADDFOT *
****************************************************************************
PROCEDURE LUL

* Returns the parameter with underline on/off printer codes

PARAMETER PPRM, PWTH

PRIVATE XRET

IF PARAMETERS() = 1
  PWTH = LEN(PPRM)
ENDIF

XUON = CHR(27)+"-1"
XUOFF = CHR(27)+"-0"

DO CASE
  CASE TYPE('PPRM') = 'C'
    XRET = PPRM
ENDCASE

XRET = PADR( XRET, PWTH, "_" )

RETURN XUON+XRET+XUOFF

* EOP: LUL *
****************************************************************************
PROCEDURE LLGLFLD

* Returns descriptions for Logical Fields
* if .t., return the description, else return ""

PARAMETERS PFLD, PDSC

IF PFLD
  RETURN PDSC
ELSE
  RETURN ""
ENDIF

* EOP: LLGLFLD *
****************************************************************************
PROCEDURE LPRTLIN

* Prints the line, if there is anything to print

PARAMETER PLIN
IF !EMPTY(PLIN)
  ? PLIN
ENDIF

RETURN
* EOP: LPRTLIN *
****************************************************************************
PROCEDURE LNUM

* Carl is lazy and wishes Fox would make this a built in function.

PARAMETERS PNUM

RETURN LTRIM( STR( PNUM ) )

* EOP: LNUM *
****************************************************************************
* EOF: l:\mo\mobak.prg
