* PROCEDURE GMAKSMY

PARAMETER PRPTNAM, PNUMHED, PNUMFOT, PNUMTIT

* PARAMETERS:
*
* PRPTNAM (C) - Name of .FRX format file.  No .FRX needed.
*               Gets changed, so pass by referance.
*               If blank, uses the .FRX open in the current area.
* PNUMHED (N) - Number of objects to move from the header to the footer
*               Defaults to all.
* PNUMFOT (N) - Number of objects to remove from the footer.
*               Defaults to none.
* PNUMTIT (N) - Number of rows of page header titles to delete objects from.
*               From bottem of page header.  Defaults to 3.

* Ajusts the FRX/FRT report form files to make a better looking summary report.
* Called when the [X] Summary option is checked, the name of the FRX file is
* passed and changed to TEMP (.FRX is implied).

* The original report should look like this:

* 1 PgHead  DETAIL TITLES (Names, Dates, ID's...)  Numeric Titles
* 2 PgHead  DETAIL TITLES (Names, Dates, ID's...)  Numeric Titles
* 3 PgHead  ====== ====== ======= ====== ========  ======= ======
* 4 GpHead  GROUP FIELDS        ADDITIONAL GROUP INFO
* 5 Detail  xxxxxx xxxxxx xxxxxxx xxxxxx xxxxxxxx  9999.99 999.99
* 6 GpFoot                                         ------- ------
* 7 GpFoot  END GROUP FIELDS   MORE GROUP FIELDS   9999.99 999.99
* 8 GpFoot
* 9 Summary                                        ======= ======
*10 Summary                                        9999.99 999.99

* The result of GMAKSMY is:
* A. check the "Report/Page Layout/Options/[X] Summary report" option
*    Uncheck "[ ] New Page" from the inner most group.
* B. remove END GROUP FIELDS
* C. move GROUP FIELDS from line 4 to line 7
* D. remove ADDITIONAL GROUP INFO
* E. delete line 6.
* F. Delete all DETAIL TITLES, execpt for ones over original fields in the
*    group footer that are not being erased
* G. Create titles in the PgHead for the GROUP FIELDS from the Comment
*    fields in GROUP FIELDS (and MORE GROUP FIELDS)

* The result should look like this:

* 1 PgHead                                         Numeric Titles
* 2 PgHead  GROUP FIELDS TITLE MORE TITLES         Numeric Titles
* 3 PgHead  ================== =================   ======= ======
* 7 GpFoot  GROUP FIELDS       MORE GROUP FIELDS   9999.99 999.99
* 9 Summary                                        ======= ======
*10 Summary                                        9999.99 999.99

* GpHead and Detail removed to represent output.

* Things it does to the FRX:
* It sets SUMMARY to .T. on record #1
* Ajusts the inermost group header and footer.  All other groups, page
* header/footer, title, summary and detail lines are un-touched.
* Changes the hight of the group footer to 1; removes the row of lines that
* generally seperate the detal from the sub-total; moves the object in the
* group header down to the group footer.  This makes for one line per group,
* plus what ever other lines and subtotals are in the outer groups, and
* summary.

PRIVATE XSEL, XHVPOS, XHHGT, XFVPOS, XHHGT, XCTR, XVPOS, XWTH, XHPOS

* XSEL (C)   - Current work area
* XGRPNO (N) - Group number to reformat (0 is innermost)
* XHVPOS (N) - Start VPOS of group header
* XHHGT (N)  - Original Height of group header
* XFVPOS (N) - Start VPOS of group footer
* XFHGT (N)  - Original Height of group header
* XCTR (N)   - loop counter
* XVPOS (N)  - Temp VPOS
* XWTH (N)   - Temp WIDTH
* XHPOS (N)  - Temp HPOS

IF !EMPTY(PRPTNAM)

  IF GDDEVEL
    WAIT WINDOW NOWAIT PRPTNAM + ": Pre-GMAKSMY"
    MODI REPO (PRPTNAM)
  ENDIF

  * Save current environment
  XSEL = SELECT()

  * Copy PRPTNAM.FRX to SMYRPT.FRX (to preserve PRPTNAM)
  SELECT * FROM (PRPTNAM+".FRX") INTO TABLE ("TEMPFRX"+".FRX")
  USE IN (PRPTNAM)

ELSE
  XSEL = ""
ENDIF
PRPTNAM = ALIAS()

* Set summary option.  Suppresses printing detail band, same as
* deleting the objects from that band.
REPLACE SUMMARY WITH .T. FOR OBJTYPE = c_othed

* Check for group bands.  If none, don't do anything.
LOCA FOR OBJTYPE = c_otBnd AND OBJCODE = c_ocGrpHed and UPPER(EXPR) <> '.T.'
IF FOUND()

  * Find the inermost group band that has info on it.
  * (accomodates when lowest band has been 'removed' by GRMVGRP)

  * For now, just skip bands that have been 'removed' by GRMVGRP.
  * that is apparent by a group expression of ".t."

  * This will be done by going to the last group header (Detail -1 )
  * and backing up till the expression is not ".t."

  LOCATE FOR OBJTYPE = c_otBnd AND OBJCODE = c_ocDet
  SKIP -1
  XGRPNO = 0
  DO WHILE OBJTYPE = c_otBnd AND OBJCODE = c_ocGrpHed and UPPER(EXPR) = ".T."
    XGRPNO = XGRPNO +1
    SKIP -1
  ENDDO

  * Get some importnant record numbers: the group header and footer pair
  * of the group that we are interested in.
  * The group levels  and the
  * header/footer pair are defined by the physical posision of the records
  * in the FRX, not any sort of level number like i think there should be.
  
  * recno of the group header (Group Header Record No.)
  XGHRNO = RECNO()

  * recno of the group footer (Group Footer Record No.)
  LOCATE FOR OBJTYPE = c_otBnd AND OBJCODE = c_ocGrpFot
  SKIP XGRPNO
  XGFRNO = RECNO()

  * Get the Height of the group header
  GOTO XGHRNO
  XHHGT = HEIGHT

  * uncheck []new page.
  REPLACE PAGEBREAK WITH .F.

  * Find the VPOS of the group header
  * (sum of all the heights of bands above it)
  SUM HEIGHT TO XHVPOS FOR OBJTYPE = c_otBnd and RECNO() < XGHRNO

  * Find the start of the group footer
  * (everything up to but not including the group footer)
  SUM HEIGHT TO XFVPOS FOR OBJTYPE = c_otBnd AND RECNO() < XGFRNO

  * Get the original height of the footer, then
  * change the height of the footer to 1
  GOTO XGFRNO
  XFHGT = HEIGHT
  REPLACE HEIGHT WITH 1

  * Do things to the objects in the footer
  SET FILTER TO !DELETED() AND INLIST( OBJTYPE, c_otTxt, c_otFld );
   AND BETWEEN( VPOS, XFVPOS, XFVPOS + XFHGT-1 )

  * If PNUMFOT was passed, delete the first PNUMFOT objects from the footer.
  IF TYPE('PNUMFOT') = 'N'

    * Find the first object and delete it. do this PNUMFOT times, and you
    * will have deleted the first PNUMFOT objects.
    FOR XCTR = 1 TO PNUMFOT

      CALC MIN(HPOS) TO XHPOS 
      DELETE FOR HPOS = XHPOS

    ENDFOR

  ENDIF

  * Delete all "---" and "===" objects on the first line of the group footer,
  * normaly they are the row of -'s that go above the sub-totals.
  DELETE FOR VPOS = XFVPOS AND INLIST( EXPR, '"-', '"=' )

  * Move everthing else in the inner group up one line.
  REPLACE ALL VPOS WITH VPOS - 1

  * End of playing with the group footer
  SET FILTER TO

  * Delete the detail titles that are not above a field in the group.
  * to do this, we will DELETE all the object on the last two lines of the
  * page header, then RECALL the ones that are above a field in the group.
  * Some of the recalled titles may get deleted later if a title is generated
  * from the comment of a field in the group footer.

  * Find the end of the first page header.
  SUM HEIGHT TO XVPOS FOR OBJTYPE = c_otBnd AND OBJCODE <= c_ocPagHed

  * Delete objects in last lines of page header
  * PNUMTIT: -3 to -1 will be the last two lines in the page header.
  PNUMTIT = IIF( EMPTY(PNUMTIT), 3, PNUMTIT )
  SET FILTER TO INLIST( OBJTYPE, c_otTxt, c_otFld  );
   AND BETWEEN( VPOS, XVPOS-PNUMTIT, XVPOS )
  DELETE ALL

  * Grab positions for all fields in the footer
  * (no text objects, just type 8 - c_otFld)
  SELECT HPOS, WIDTH FROM (PRPTNAM+".FRX") INTO CURSOR QGF ;
   WHERE !DELETED() AND INLIST( OBJTYPE, c_otFld );
     AND BETWEEN( VPOS, XFVPOS, XFVPOS + XFHGT-1 )

  * For each object in the group footer, recall the ojbects in the page header
  * that overlap.
  SCAN
    SELECT (PRPTNAM)
    RECALL FOR HPOS <= QGF.HPOS+QGF.WIDTH AND HPOS+WIDTH >= QGF.HPOS
  ENDSCAN
  USE
  SELECT (PRPTNAM)
  SET FILTER TO

  * Move objects from the header to the footer.
  * If PNUMHED is passed, only move the first PNUMHED objects and delete the rest,
  * else move all of the objects to the footer.
  SET FILTER TO INLIST( OBJTYPE, 8, 5 );
   AND BETWEEN( VPOS, XHVPOS, XHVPOS + XHHGT-1 )

  IF TYPE('PNUMHED') = 'N'

    FOR XCTR = 1 TO PNUMHED

      CALC MIN(HPOS) TO XHPOS
      REPLACE VPOS WITH XFVPOS FOR HPOS = XHPOS

    ENDFOR

    DELETE ALL

  ELSE

    REPLACE ALL VPOS WITH XFVPOS

  ENDIF

  * Done moving objects from header to footer
  SET FILTER TO

  * Create titles (stored in comments) for the group info
  * First, get all titles from comments
  SELECT HPOS, WIDTH, COMMENT FROM (PRPTNAM+".FRX") INTO CURSOR QGT ;
   WHERE "#TTL"$COMMENT AND !DELETED() AND INLIST( OBJTYPE, c_otFld );
   AND BETWEEN( VPOS, XFVPOS, XFVPOS + XFHGT-1 )

  * Now delete the titles that would be overlapped by the new title,
  * and add the new title objects.
  SCAN
    SELECT (PRPTNAM)
    DELETE FOR OBJTYPE=c_otTxt and;
     (BETWEEN(HPOS, QGT.HPOS, QGT.HPOS+QGT.WIDTH) or;
      BETWEEN(HPOS+WIDTH, QGT.HPOS, QGT.HPOS+QGT.WIDTH)) and;
     BETWEEN(VPOS, XVPOS-3, XVPOS)
    INSERT INTO (PRPTNAM+".FRX");
     ( PLATFORM, OBJTYPE, OBJCODE, HPOS, VPOS, WIDTH, EXPR, FLOAT ) ;
     VALUES ( "DOS", c_otTxt, 0, QGT.HPOS, XVPOS-2, ;
     LEN(QGT.COMMENT)-4, '"'+STRT(QGT.COMMENT,"#TTL")+'"', .T. )
    INSERT INTO (PRPTNAM+".FRX");
     ( PLATFORM, OBJTYPE, OBJCODE, HPOS, VPOS, WIDTH, EXPR, FLOAT ) ;
     VALUES ( "DOS", c_otTxt, 0, QGT.HPOS, XVPOS-1, ;
     QGT.WIDTH, '"'+REPLICATE("=",QGT.WIDTH)+'"', .T. )
  ENDSCAN
  USE
  SELECT (PRPTNAM)

  * Move all other objects up.  XFHGT was the original height of the group footer,
  * now its hight is 1, so XFHGT-1 is the number of lines they need to be moved up.
  * XFVPOS+XFHGT = VPOS of first band after the original goup footer.
  REPLACE VPOS WITH VPOS - (XFHGT-1) ;
   FOR INLIST( OBJTYPE, c_otTxt, c_otFld ) AND VPOS >= XFVPOS+XFHGT

  PACK

ENDIF && FOUND() group band.

IF !EMPTY(XSEL)

  * Close the FRX database.
  USE

  * Restore the original select area
  SELECT (XSEL)

ENDIF

* EOP: GMAKSMY *
