* Program i:\frx\scx2frx.prg

* Makes a FRX report from a SCX screen file.

* By Carl Karsten CIS:73252,3340

* Tue  05-10-1994

SET TALK OFF

IF FILE('SCX2FRX.MEM')
  RESTORE FROM SCX2FRX ADDITIVE
ENDIF

DO SCX2FRX.SPX

RETURN
****************************************************************************
PROCEDURE LGO

SAVE ALL LIKE Z* TO SCX2FRX

#DEFINE c_otscreen         1
#DEFINE c_otworkarea       2
#DEFINE c_otindex          3
#DEFINE c_otrel			   4
#DEFINE c_ottext           5
#DEFINE c_otline           6
#DEFINE c_otbox            7
#DEFINE c_otlist          11
#DEFINE c_ottxtbut        12
#DEFINE c_otradbut        13
#DEFINE c_otchkbox        14
#DEFINE c_otfield         15
#DEFINE c_otpopup         16
#DEFINE c_otpicture       17
#DEFINE c_otinvbut        20
#DEFINE c_otspinner       22

#DEFINE c_sgsay            0
#DEFINE c_sgget            1
#DEFINE c_sgedit           2
#DEFINE c_sgfrom           3
#DEFINE c_sgbox            4
#DEFINE c_sgboxd           5
#DEFINE c_sgboxp           6
#DEFINE c_sgboxc           7

* Set up XALS, which is what any M.'s will get changed to.
IF EMPTY(ZALS)
  XALS = ''
ELSE
  XALS = TRIM(ZALS)+'.'
ENDIF

* Name of destination file (report)
XFRXNAM = ZFRXNAM+".FRX"

USE (ZSCXNAM+".SCX") ALIAS SCX

* Delete any existing destination
IF FILE(XFRXNAM)
  IF SET('SAFETY') = 'ON'
    WAIT WINDOW "Overwrite "+XFRXNAM+"?" TO XANS
    IF UPPER(XANS)<>'Y'
      CANCEL
    ENDIF
  ENDIF
  ERASE (XFRXNAM)  && This leaves the .FRT file, but it seems ok.
ENDIF

* Create a blank .FRX
* Report, Title/Summary...,
KEYBOARD "{Alt+O}YTS{Ctrl+Enter}"
KEYBOARD "{Ctrl+W}N"    &&  Save and exit, "Save environment information?" No.
MODIFY REPORT (XFRXNAM)

USE (XFRXNAM) ALIAS FRX IN 0

* Change width and height of detail band to match SCX
SELECT SCX
LOCATE FOR OBJTYPE = 1

SELECT FRX
REPLACE WIDTH WITH SCX.WIDTH FOR OBJTYPE = 1
REPLACE HEIGHT WITH SCX.HEIGHT FOR OBJTYPE = 9 AND OBJCODE = 4

* Set page eject options from users setttings.
REPLACE Ejectbefor WITH ZEJTBEF, Ejectafter WITH ZEJTAFT FOR OBJTYPE = 1

* find amount to ajust VPOS by (size of headers)
SUM HEIGHT TO XVPOSOFF FOR OBJTYPE = 9 AND OBJCODE <= 3

* Copy ojbects from SCX to FRX

SELECT SCX

SCAN

  DO CASE

    CASE OBJTYPE = c_otText
      DO LTXT WITH HPOS, VPOS, EXPR

    CASE OBJTYPE = c_otchkbox
      DO LCHK

    CASE OBJTYPE = c_otfield AND OBJCODE = c_sgsay
      DO LFLD WITH HPOS, VPOS, LNOM(EXPR), WIDTH, 1, PICTURE

    CASE OBJTYPE = c_otfield AND OBJCODE = c_sgget
      DO LFLD WITH HPOS, VPOS, LNOM(NAME), WIDTH, 1, PICTURE

    CASE OBJTYPE = c_otfield AND OBJCODE = c_sgedit
      DO LFLD WITH HPOS, VPOS, LNOM(NAME), WIDTH, HEIGHT, PICTURE, .T.

    CASE OBJTYPE = c_otradbut
      DO LRDO

  ENDCASE

ENDSCAN

USE IN SCX
USE IN FRX

MODI REPORT (PNAM)

SET TALK ON

RETURN
****************************************************************************
PROCEDURE LTXT

* Adds a Text object to the FRX

PARAMETERS PHPOS, PVPOS, PTXT

M.PLATFORM = "DOS"
M.OBJTYPE = 5
M.OBJCODE = 0
M.HPOS = PHPOS 
M.VPOS = PVPOS + XVPOSOFF
M.WIDTH = LEN(PTXT) - 2 && 2 quotes on each end
M.EXPR = PTXT

M.FLOAT = .T.

INSERT INTO (XFRXNAM) FROM MEMVAR

RETURN
* EOP: LTXT *
****************************************************************************
PROCEDURE LFLD

* Adds a Field to the FRX

PARAMETERS PHPOS, PVPOS, PFLD, PWTH, PHGT, PPIC, PSTR

M.PLATFORM = "DOS"
M.OBJTYPE = 8
M.OBJCODE = 0
M.HPOS = PHPOS
M.VPOS = PVPOS + XVPOSOFF
M.WIDTH = PWTH
M.EXPR = PFLD
M.HEIGHT = IIF( TYPE('PHGT')='N', PHGT, 1 )
M.PICTURE = IIF( TYPE('PPIC')='C', PPIC, '' )
M.STRETCH = PSTR

M.FLOAT = .T.

INSERT INTO (XFRXNAM) FROM MEMVAR

RETURN
* EOP: LFLD *
****************************************************************************
PROCEDURE LCHK

* Check Box

* [ + field + ] + check box text

* field will evaluate to "X" or " ", based on EMPTY()
* so field can be any type.

PRIVATE XPCT, XMRK

XPCT = SUBSTR( PICTURE, 6 )

DO CASE
  CASE ZCHKCHR = 1
    XMRK = 'X'
  CASE ZCHKCHR = 2
    XMRK = SUBSTR( XPCT, 1, 1 )
  CASE ZCHKCHR = 3
    IF "\<" $ XPCT
      XMRK = SUBSTR( XPCT, AT( "\<", XPCT )+3 )
    ELSE
      XMRK = SUBSTR( XPCT, 1, 1 )
    ENDIF
ENDCASE

* Take out short-cut key definition
XPCT = LNOSHO( XPCT )

DO LTXT WITH HPOS, VPOS, '"["'
DO LFLD WITH HPOS+1, VPOS, 'IIF( !EMPTY('+LNOM(NAME)+'), "'+XMRK+'", " " )', 1
DO LTXT WITH HPOS+2, VPOS, '"]"'
DO LTXT WITH HPOS+4, VPOS, '"'+ SUBSTR( XPCT, 6 )

RETURN
* EOP: LCHK *
****************************************************************************
PROCEDURE LRDO

* Radio Buttons

* if the type is NUMERIC:
* ( + field + ) + radio button text
* ( + field + ) + radio button text
* ( + field + ) + radio button text
* one for each option in the picture clause.
* one of the fields will evaluate to "*", the rest will be " "

* if the type is CHAR: (NOT SUPPORTED!)
* (*) + field

* Remove the '"@*RVN ' and the ending '"' from picure, and
* add '; ' to the end of it to make the XTXT= and XPCT= work.

XPCT = SUBSTR(PICTURE,8,LEN(PICTURE)-8)+"; "
XCTR = 0
DO WHILE !EMPTY(XPCT)

  XTXT = SUBSTR( XPCT, 1, AT( ";", XPCT )-1 )
  XPCT = SUBSTR( XPCT, AT( ";", XPCT )+1 )

  DO LTXT WITH HPOS, VPOS+XCTR, '"("'
  DO LFLD WITH HPOS+1, VPOS+XCTR, 'IIF( '+LNOM(NAME)+'='+LNUM(XCTR+1)+', "*", " " )', 1
  DO LTXT WITH HPOS+2, VPOS+XCTR, '") '+ XTXT + '"'

  XCTR = XCTR + 1

ENDDO

RETURN
* EOP: LRDO *
****************************************************************************
PROCEDURE LNOM

* Takes the M. off the front of a fields

PARAMETER PFLD

PRIVATE XCTR

IF ZNOM

  * Look for leading M.

  IF PFLD = "M."
    PFLD = XALS + SUBSTR(PFLD,3)
  ENDIF

  * Look for M.'s embeded in expressions

  XCTR = 2
  DO WHILE XCTR <= LEN(PFLD)-2
    IF SUBSTR(PFLD,XCTR,2) = "M." AND !ISALPHA(SUBSTR(PFLD,XCTR-1,1))
      PFLD = STUF(PFLD, XCTR, 2, XALS )
      XCTR = XCTR -2
    ENDIF
    XCTR = XCTR +1
  ENDDO

ENDIF

RETURN PFLD
* EOP: LNOM *
****************************************************************************
PROCEDURE LNOSHO

* Removes the first "\<" from the passed parameter, if one exists.

PARAMETER PPCT

IF "\<" $ PPCT
  PPCT = STUFF( PPCT, AT( "\<", PPCT ), 2, "" )
ENDIF

RETURN PPCT
* EOP: LNOSHO *
****************************************************************************
PROCEDURE LNUM

* Carl is lazy and wishes Fox would make this a built in function.

PARAMETERS PNUM

RETURN LTRIM( STR( PNUM ) )

* EOP: LNUM *
****************************************************************************
* EOF: i:\frx\scx2frx.prg *
